diff --git a/contrib/amd/amd/info_exec.c b/contrib/amd/amd/info_exec.c
new file mode 100644
index 0000000..8ccab9a
--- /dev/null
+++ b/contrib/amd/amd/info_exec.c
@@ -0,0 +1,423 @@
+/*
+ * Copyright (c) 1997-2006 Erez Zadok
+ * Copyright (c) 1990 Jan-Simon Pendry
+ * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
+ * Copyright (c) 1990 The Regents of the University of California.
+ * All rights reserved.
+ *
+ * This code is derived from software contributed to Berkeley by
+ * Jan-Simon Pendry at Imperial College, London.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ *    must display the following acknowledgment:
+ *      This product includes software developed by the University of
+ *      California, Berkeley and its contributors.
+ * 4. Neither the name of the University nor the names of its contributors
+ *    may be used to endorse or promote products derived from this software
+ *    without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ *
+ *
+ * File: am-utils/amd/info_exec.c
+ *
+ */
+
+/*
+ * Get info from executable map
+ *
+ * Original from Erik Kline, 2004.
+ */
+
+#ifdef HAVE_CONFIG_H
+# include <config.h>
+#endif /* HAVE_CONFIG_H */
+#include <am_defs.h>
+#include <amd.h>
+
+#define	MAX_LINE_LEN		1500
+
+/* forward declarations */
+int exec_init(mnt_map *m, char *map, time_t *tp);
+int exec_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp);
+
+
+/*
+ * a timed fgets()
+ */
+static char *
+fgets_timed(char *s, int size, int rdfd, int secs)
+{
+  fd_set fds;
+  struct timeval timeo;
+  time_t start, now;
+  int rval=0, i=0;
+
+  if (!s || size < 0 || rdfd < 0)
+    return 0;
+
+  s[0] = 0;
+  if (size == 0)
+    return s;
+
+  start = clocktime(NULL);
+  while (s[i] != '\n'  &&  i < size-1) {
+    s[i+1] = 0; /* places the requisite trailing '\0' */
+
+    /* ready for reading */
+    rval = read(rdfd, (void *)(s+i), 1);
+    if (rval == 1) {
+      if (s[i] == 0) {
+        rval = 0;
+        break;
+      }
+      i++;
+      continue;
+    } else if (rval == 0) {
+      break;
+    } else if (rval < 0  &&  errno != EAGAIN  &&  errno != EINTR) {
+      plog(XLOG_WARNING, "fgets_timed read error: %m");
+      break;
+    }
+
+    timeo.tv_usec = 0;
+    now = clocktime(NULL) - start;
+    if (secs <= 0)
+      timeo.tv_sec = 0;
+    else if (now < secs)
+      timeo.tv_sec = secs - now;
+    else {
+      /* timed out (now>=secs) */
+      plog(XLOG_WARNING, "executable map read timed out (> %d secs)", secs);
+      rval = -1;
+      break;
+    }
+
+    FD_ZERO(&fds);
+    FD_SET(rdfd, &fds);
+
+    rval = select(rdfd+1, &fds, 0, 0, &timeo);
+    if (rval < 0) {
+      /* error selecting */
+      plog(XLOG_WARNING, "fgets_timed select error: %m");
+      if (errno == EINTR)
+        continue;
+      rval = -1;
+      break;
+    } else if (rval == 0) {
+      /* timed out */
+      plog(XLOG_WARNING, "executable map read timed out (> %d secs)", secs);
+      rval = -1;
+      break;
+    }
+  }
+
+  if (rval > 0)
+    return s;
+
+  close(rdfd);
+  return (rval == 0 ? s : 0);
+}
+
+
+static int
+read_line(char *buf, int size, int fd)
+{
+  int done = 0;
+
+  while (fgets_timed(buf, size, fd, gopt.exec_map_timeout)) {
+    int len = strlen(buf);
+    done += len;
+    if (len > 1  &&  buf[len - 2] == '\\' &&
+        buf[len - 1] == '\n') {
+      buf += len - 2;
+      size -= len - 2;
+      *buf = '\n';
+      buf[1] = '\0';
+    } else {
+      return done;
+    }
+  }
+
+  return done;
+}
+
+
+/*
+ * Try to locate a value in a query answer
+ */
+static int
+exec_parse_qanswer(int fd, char *map, char *key, char **pval, time_t *tp)
+{
+  char qanswer[MAX_LINE_LEN], *dc = 0;
+  int chuck = 0;
+  int line_no = 0;
+
+  while (read_line(qanswer, sizeof(qanswer), fd)) {
+    char *cp;
+    char *hash;
+    int len = strlen(qanswer);
+    line_no++;
+
+    /*
+     * Make sure we got the whole line
+     */
+    if (qanswer[len - 1] != '\n') {
+      plog(XLOG_WARNING, "line %d in \"%s\" is too long", line_no, map);
+      chuck = 1;
+    } else {
+      qanswer[len - 1] = '\0';
+    }
+
+    /*
+     * Strip comments
+     */
+    hash = strchr(qanswer, '#');
+    if (hash)
+      *hash = '\0';
+
+    /*
+     * Find beginning of value (query answer)
+     */
+    for (cp = qanswer; *cp && !isascii((int)*cp) && !isspace((int)*cp); cp++)
+      ;;
+
+    /* Ignore blank lines */
+    if (!*cp)
+      goto again;
+
+    /*
+     * Return a copy of the data
+     */
+    dc = strdup(cp);
+    *pval = dc;
+    dlog("%s returns %s", key, dc);
+
+    close(fd);
+    return 0;
+
+  again:
+    /*
+     * If the last read didn't get a whole line then
+     * throw away the remainder before continuing...
+     */
+    if (chuck) {
+      while (fgets_timed(qanswer, sizeof(qanswer), fd, gopt.exec_map_timeout) &&
+	     !strchr(qanswer, '\n')) ;
+      chuck = 0;
+    }
+  }
+
+  return ENOENT;
+}
+
+
+static int
+set_nonblock(int fd)
+{
+  int val;
+
+  if (fd < 0)
+     return 0;
+
+  if ((val = fcntl(fd, F_GETFL, 0)) < 0) {
+    plog(XLOG_WARNING, "set_nonblock fcntl F_GETFL error: %m");
+    return 0;
+  }
+
+  val |= O_NONBLOCK;
+  if (fcntl(fd, F_SETFL, val) < 0) {
+    plog(XLOG_WARNING, "set_nonblock fcntl F_SETFL error: %m");
+    return 0;
+  }
+
+  return 1;
+}
+
+
+static int
+exec_map_open(char *emap, char *key)
+{
+  pid_t p1, p2;
+  int pdes[2], nullfd, i;
+  char *argv[3];
+
+  if (!emap)
+    return 0;
+
+  argv[0] = emap;
+  argv[1] = key;
+  argv[2] = NULL;
+
+  if ((nullfd = open("/dev/null", O_WRONLY|O_NOCTTY)) < 0)
+    return -1;
+
+  if (pipe(pdes) < 0) {
+    close(nullfd);
+    return -1;
+  }
+
+  switch ((p1 = vfork())) {
+  case -1:
+    /* parent: fork error */
+    close(nullfd);
+    close(pdes[0]);
+    close(pdes[1]);
+    return -1;
+  case 0:
+    /* child #1 */
+    p2 = vfork();
+    switch (p2) {
+    case -1:
+      /* child #1: fork error */
+      exit(errno);
+    case 0:
+      /* child #2: init will reap our status */
+      if (pdes[1] != STDOUT_FILENO) {
+	dup2(pdes[1], STDOUT_FILENO);
+	close(pdes[1]);
+      }
+
+      if (nullfd != STDERR_FILENO) {
+	dup2(nullfd, STDERR_FILENO);
+	close(nullfd);
+      }
+
+      for (i=0; i<FD_SETSIZE; i++)
+	if (i != STDOUT_FILENO  &&  i != STDERR_FILENO)
+	  close(i);
+
+      /* make the write descriptor non-blocking */
+      if (!set_nonblock(STDOUT_FILENO)) {
+	close(STDOUT_FILENO);
+	exit(-1);
+      }
+
+      execve(emap, argv, NULL);
+      exit(errno);		/* in case execve failed */
+    }
+
+    /* child #1 */
+    exit(0);
+  }
+
+  /* parent */
+  close(nullfd);
+  close(pdes[1]);
+
+  /* anti-zombie insurance */
+  while (waitpid(p1,0,0) < 0)
+    if (errno != EINTR)
+      exit(errno);
+
+  /* make the read descriptor non-blocking */
+  if (!set_nonblock(pdes[0])) {
+    close(pdes[0]);
+    return -1;
+  }
+
+  return pdes[0];
+}
+
+
+/*
+ * Check for various permissions on executable map without trying to
+ * fork a new executable-map process.
+ *
+ * return: >0 (errno) if failed
+ *          0 if ok
+ */
+static int
+exec_check_perm(char *map)
+{
+  struct stat sb;
+
+  /* sanity and permission checks */
+  if (!map) {
+    dlog("exec_check_permission got a NULL map");
+    return EINVAL;
+  }
+  if (stat(map, &sb)) {
+    plog(XLOG_ERROR, "map \"%s\" stat failure: %m", map);
+    return errno;
+  }
+  if (!S_ISREG(sb.st_mode)) {
+    plog(XLOG_ERROR, "map \"%s\" should be regular file", map);
+    return EINVAL;
+  }
+  if (sb.st_uid != 0) {
+    plog(XLOG_ERROR, "map \"%s\" owned by uid %u (must be 0)", map, (u_int) sb.st_uid);
+    return EACCES;
+  }
+  if (!(sb.st_mode & S_IXUSR)) {
+    plog(XLOG_ERROR, "map \"%s\" should be executable", map);
+    return EACCES;
+  }
+  if (sb.st_mode & (S_ISUID|S_ISGID)) {
+    plog(XLOG_ERROR, "map \"%s\" should not be setuid/setgid", map);
+    return EACCES;
+  }
+  if (sb.st_mode & S_IWOTH) {
+    plog(XLOG_ERROR, "map \"%s\" should not be world writeable", map);
+    return EACCES;
+  }
+
+  return 0;			/* all is well */
+}
+
+
+int
+exec_init(mnt_map *m, char *map, time_t *tp)
+{
+  /*
+   * Basically just test that the executable map can be found
+   * and has proper permissions.
+   */
+  return exec_check_perm(map);
+}
+
+
+int
+exec_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
+{
+  int mapfd, ret;
+
+  if ((ret = exec_check_perm(map)) != 0) {
+    return ret;
+  }
+
+  if (!key)
+    return 0;
+
+  if (logfp)
+    fflush(logfp);
+  dlog("exec_search \"%s\", key: \"%s\"", map, key);
+  mapfd = exec_map_open(map, key);
+
+  if (mapfd >= 0) {
+    if (tp)
+      *tp = clocktime(NULL);
+
+    return exec_parse_qanswer(mapfd, map, key, pval, tp);
+  }
+
+  return errno;
+}
diff --git a/contrib/amd/amd/info_file.c b/contrib/amd/amd/info_file.c
index e235752..3777a2a 100644
--- a/contrib/amd/amd/info_file.c
+++ b/contrib/amd/amd/info_file.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_file.c,v 1.2 1999/01/10 21:53:45 ezk Exp $
+ * File: am-utils/amd/info_file.c
  *
  */
 
@@ -55,14 +54,13 @@
 #define	MAX_LINE_LEN	1500
 
 /* forward declarations */
-int file_init(mnt_map *m, char *map, time_t *tp);
+int file_init_or_mtime(mnt_map *m, char *map, time_t *tp);
 int file_reload(mnt_map *m, char *map, void (*fn) (mnt_map *, char *, char *));
 int file_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp);
-int file_mtime(mnt_map *m, char *map, time_t *tp);
 
 
 static int
-read_line(char *buf, int size, FILE * fp)
+read_line(char *buf, int size, FILE *fp)
 {
   int done = 0;
 
@@ -87,7 +85,7 @@ read_line(char *buf, int size, FILE * fp)
 	return done;
       }
     }
-  } while (size > 0 && !feof(fp));
+  } while (size > 0 && !feof(fp) && !ferror(fp));
 
   return done;
 }
@@ -97,7 +95,12 @@ read_line(char *buf, int size, FILE * fp)
  * Try to locate a key in a file
  */
 static int
-search_or_reload_file(FILE * fp, char *map, char *key, char **val, mnt_map *m, void (*fn) (mnt_map *m, char *, char *))
+file_search_or_reload(FILE *fp,
+		      char *map,
+		      char *key,
+		      char **val,
+		      mnt_map *m,
+		      void (*fn) (mnt_map *m, char *, char *))
 {
   char key_val[MAX_LINE_LEN];
   int chuck = 0;
@@ -161,9 +164,7 @@ search_or_reload_file(FILE * fp, char *map, char *key, char **val, mnt_map *m, v
 	  (*fn) (m, strdup(kp), dc);
 	} else {
 	  *val = dc;
-#ifdef DEBUG
 	  dlog("%s returns %s", key, dc);
-#endif /* DEBUG */
 	}
 	if (!fn)
 	  return 0;
@@ -196,7 +197,7 @@ file_open(char *map, time_t *tp)
   if (mapf && tp) {
     struct stat stb;
     if (fstat(fileno(mapf), &stb) < 0)
-      *tp = clocktime();
+      *tp = clocktime(NULL);
     else
       *tp = stb.st_mtime;
   }
@@ -205,7 +206,7 @@ file_open(char *map, time_t *tp)
 
 
 int
-file_init(mnt_map *m, char *map, time_t *tp)
+file_init_or_mtime(mnt_map *m, char *map, time_t *tp)
 {
   FILE *mapf = file_open(map, tp);
 
@@ -223,7 +224,7 @@ file_reload(mnt_map *m, char *map, void (*fn) (mnt_map *, char *, char *))
   FILE *mapf = file_open(map, (time_t *) 0);
 
   if (mapf) {
-    int error = search_or_reload_file(mapf, map, 0, 0, m, fn);
+    int error = file_search_or_reload(mapf, map, 0, 0, m, fn);
     (void) fclose(mapf);
     return error;
   }
@@ -243,23 +244,10 @@ file_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
       *tp = t;
       error = -1;
     } else {
-      error = search_or_reload_file(mapf, map, key, pval, 0, 0);
+      error = file_search_or_reload(mapf, map, key, pval, 0, 0);
     }
     (void) fclose(mapf);
     return error;
   }
   return errno;
 }
-
-
-int
-file_mtime(mnt_map *m, char *map, time_t *tp)
-{
-  FILE *mapf = file_open(map, tp);
-
-  if (mapf) {
-    (void) fclose(mapf);
-    return 0;
-  }
-  return errno;
-}
diff --git a/contrib/amd/amd/info_hesiod.c b/contrib/amd/amd/info_hesiod.c
index 62007d6..e345c99 100644
--- a/contrib/amd/amd/info_hesiod.c
+++ b/contrib/amd/amd/info_hesiod.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1989 Jan-Simon Pendry
  * Copyright (c) 1989 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1989 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_hesiod.c,v 1.5 1999/02/04 07:24:15 ezk Exp $
+ * File: am-utils/amd/info_hesiod.c
  *
  */
 
@@ -75,13 +74,11 @@ int hesiod_isup(mnt_map *m, char *map);
 int
 amu_hesiod_init(mnt_map *m, char *map, time_t *tp)
 {
-#ifdef DEBUG
   dlog("amu_hesiod_init(%s)", map);
-#endif /* DEBUG */
   *tp = 0;
 
 #ifdef HAVE_HESIOD_INIT
-  if(!hesiod_context && hesiod_init(&hesiod_context) != 0)
+  if (!hesiod_context && hesiod_init(&hesiod_context) != 0)
     return ENOENT;
 #endif /* HAVE_HESIOD_INIT */
 
@@ -102,22 +99,21 @@ hesiod_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
   int error;
 #endif /* not HAVE_HESIOD_INIT */
 
-#ifdef DEBUG
   dlog("hesiod_search(m=%lx, map=%s, key=%s, pval=%lx tp=%lx)",
        (unsigned long) m, map, key, (unsigned long) pval, (unsigned long) tp);
-#endif /* DEBUG */
 
-  sprintf(hes_key, "%s.%s", key, map + HES_PREFLEN);
+  if (key[0] == '.')
+    return ENOENT;
+
+  xsnprintf(hes_key, sizeof(hes_key), "%s.%s", key, map + HES_PREFLEN);
 
   /*
    * Call the resolver
    */
-#ifdef DEBUG
   dlog("Hesiod base is: %s\n", gopt.hesiod_base);
   dlog("hesiod_search: hes_resolve(%s, %s)", hes_key, gopt.hesiod_base);
-  if (debug_flags & D_INFO)
+  if (amuDebug(D_INFO))
     _res.options |= RES_DEBUG;
-#endif /* DEBUG */
 
 #ifdef HAVE_HESIOD_INIT
   /* new style hesiod */
@@ -144,9 +140,7 @@ hesiod_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
   /*
    * Otherwise reflect the hesiod error into a Un*x error
    */
-# ifdef DEBUG
   dlog("hesiod_search: Error: %d", hes_error());
-# endif /* DEBUG */
   switch (hes_error()) {
   case HES_ER_NOTFOUND:
     error = ENOENT;
@@ -161,9 +155,7 @@ hesiod_search(mnt_map *m, char *map, char *key, char **pval, time_t *tp)
     error = EINVAL;
     break;
   }
-# ifdef DEBUG
   dlog("hesiod_search: Returning: %d", error);
-# endif /* DEBUG */
   return error;
 #endif /* not HAVE_HESIOD_INIT */
 }
@@ -183,9 +175,7 @@ hesiod_isup(mnt_map *m, char *map)
   static int last_status = 1;	/* assume up by default */
 
   error = hesiod_search(m, map, "/defaults", &val, &mtime);
-#ifdef DEBUG
   dlog("hesiod_isup(%s): %s", map, strerror(error));
-#endif /* DEBUG */
   if (error != 0 && error != ENOENT) {
     plog(XLOG_ERROR,
 	 "hesiod_isup: error getting `/defaults' entry in map %s: %m", map);
diff --git a/contrib/amd/amd/info_ldap.c b/contrib/amd/amd/info_ldap.c
index a2bd9ba..36ce1c8 100644
--- a/contrib/amd/amd/info_ldap.c
+++ b/contrib/amd/amd/info_ldap.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1989 Jan-Simon Pendry
  * Copyright (c) 1989 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1989 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: info_ldap.c,v 1.6 1999/09/30 21:01:31 ezk Exp $
+ * File: am-utils/amd/info_ldap.c
  *
  */
 
@@ -48,6 +47,20 @@
  * LDAP Home Page: http://www.umich.edu/~rsug/ldap/
  */
 
+/*
+ * WARNING: as of Linux Fedora Core 5 (which comes with openldap-2.3.9), the
+ * ldap.h headers deprecate several functions used in this file, such as
+ * ldap_unbind.  You get compile errors about missing extern definitions.
+ * Those externs are still in <ldap.h>, but surrounded by an ifdef
+ * LDAP_DEPRECATED.  I am turning on that ifdef here, under the assumption
+ * that the functions may be deprecated, but they still work for this
+ * (older?) version of the LDAP API.  It gets am-utils to compile, but it is
+ * not clear if it will work perfectly.
+ */
+#ifndef LDAP_DEPRECATED
+# define LDAP_DEPRECATED 1
+#endif /* not LDAP_DEPRECATED */
+
 #ifdef HAVE_CONFIG_H
 # include <config.h>
 #endif /* HAVE_CONFIG_H */
@@ -81,14 +94,14 @@
  */
 typedef struct ald_ent ALD;
 typedef struct cr_ent CR;
-typedef struct he_ent HE;
+typedef struct he_ent HE_ENT;
 
 /*
  * STRUCTURES:
  */
 struct ald_ent {
   LDAP *ldap;
-  HE *hostent;
+  HE_ENT *hostent;
   CR *credentials;
   time_t timestamp;
 };
@@ -109,7 +122,7 @@ struct he_ent {
  * FORWARD DECLARATIONS:
  */
 static int amu_ldap_rebind(ALD *a);
-static int get_ldap_timestamp(LDAP *ld, char *map, time_t *ts);
+static int get_ldap_timestamp(ALD *a, char *map, time_t *ts);
 
 
 /*
@@ -117,7 +130,7 @@ static int get_ldap_timestamp(LDAP *ld, char *map, time_t *ts);
  */
 
 static void
-he_free(HE *h)
+he_free(HE_ENT *h)
 {
   XFREE(h->host);
   if (h->next != NULL)
@@ -126,25 +139,26 @@ he_free(HE *h)
 }
 
 
-static HE *
-string2he(char *s)
+static HE_ENT *
+string2he(char *s_orig)
 {
   char *c, *p;
-  HE *new, *old = NULL;
+  char *s;
+  HE_ENT *new, *old = NULL;
 
-  if (s == NULL)
-    return (NULL);
+  if (NULL == s_orig || NULL == (s = strdup(s_orig)))
+    return NULL;
   for (p = s; p; p = strchr(p, ',')) {
     if (old != NULL) {
-      new = (HE *) xmalloc(sizeof(HE));
+      new = ALLOC(HE_ENT);
       old->next = new;
       old = new;
     } else {
-      old = (HE *) xmalloc(sizeof(HE));
+      old = ALLOC(HE_ENT);
       old->next = NULL;
     }
     c = strchr(p, ':');
-    if (c) {			/* Host and port */
+    if (c) {            /* Host and port */
       *c++ = '\0';
       old->host = strdup(p);
       old->port = atoi(c);
@@ -152,6 +166,7 @@ string2he(char *s)
       old->host = strdup(p);
 
   }
+  XFREE(s);
   return (old);
 }
 
@@ -165,13 +180,54 @@ cr_free(CR *c)
 }
 
 
+/*
+ * Special ldap_unbind function to handle SIGPIPE.
+ * We first ignore SIGPIPE, in case a remote LDAP server was
+ * restarted, then we reinstall the handler.
+ */
+static int
+amu_ldap_unbind(LDAP *ld)
+{
+  int e;
+#ifdef HAVE_SIGACTION
+  struct sigaction sa;
+#else /* not HAVE_SIGACTION */
+  void (*handler)(int);
+#endif /* not HAVE_SIGACTION */
+
+  dlog("amu_ldap_unbind()\n");
+
+#ifdef HAVE_SIGACTION
+  sa.sa_handler = SIG_IGN;
+  sa.sa_flags = 0;
+  sigemptyset(&(sa.sa_mask));
+  sigaddset(&(sa.sa_mask), SIGPIPE);
+  sigaction(SIGPIPE, &sa, &sa);	/* set IGNORE, and get old action */
+#else /* not HAVE_SIGACTION */
+  handler = signal(SIGPIPE, SIG_IGN);
+#endif /* not HAVE_SIGACTION */
+
+  e = ldap_unbind(ld);
+
+#ifdef HAVE_SIGACTION
+  sigemptyset(&(sa.sa_mask));
+  sigaddset(&(sa.sa_mask), SIGPIPE);
+  sigaction(SIGPIPE, &sa, NULL);
+#else /* not HAVE_SIGACTION */
+  (void) signal(SIGPIPE, handler);
+#endif /* not HAVE_SIGACTION */
+
+  return e;
+}
+
+
 static void
 ald_free(ALD *a)
 {
   he_free(a->hostent);
   cr_free(a->credentials);
   if (a->ldap != NULL)
-    ldap_unbind(a->ldap);
+    amu_ldap_unbind(a->ldap);
   XFREE(a);
 }
 
@@ -182,27 +238,29 @@ amu_ldap_init(mnt_map *m, char *map, time_t *ts)
   ALD *aldh;
   CR *creds;
 
+  dlog("-> amu_ldap_init: map <%s>\n", map);
+
   /*
    * XXX: by checking that map_type must be defined, aren't we
    * excluding the possibility of automatic searches through all
    * map types?
    */
   if (!gopt.map_type || !STREQ(gopt.map_type, AMD_LDAP_TYPE)) {
-    return (ENOENT);
-  }
-#ifdef DEBUG
-  else {
+    dlog("amu_ldap_init called with map_type <%s>\n",
+	 (gopt.map_type ? gopt.map_type : "null"));
+  } else {
     dlog("Map %s is ldap\n", map);
   }
-#endif /* DEBUG */
-
-  aldh = (ALD *) xmalloc(sizeof(ALD));
-  creds = (CR *) xmalloc(sizeof(CR));
 
+  aldh = ALLOC(ALD);
+  creds = ALLOC(CR);
+  aldh->ldap = NULL;
   aldh->hostent = string2he(gopt.ldap_hostports);
   if (aldh->hostent == NULL) {
     plog(XLOG_USER, "Unable to parse hostport %s for ldap map %s",
-	 gopt.ldap_hostports, map);
+	 gopt.ldap_hostports ? gopt.ldap_hostports : "(null)", map);
+    XFREE(creds);
+    XFREE(aldh);
     return (ENOENT);
   }
   creds->who = "";
@@ -210,22 +268,17 @@ amu_ldap_init(mnt_map *m, char *map, time_t *ts)
   creds->method = LDAP_AUTH_SIMPLE;
   aldh->credentials = creds;
   aldh->timestamp = 0;
-#ifdef DEBUG
+  aldh->ldap = NULL;
   dlog("Trying for %s:%d\n", aldh->hostent->host, aldh->hostent->port);
-#endif /* DEBUG */
   if (amu_ldap_rebind(aldh)) {
     ald_free(aldh);
     return (ENOENT);
   }
   m->map_data = (void *) aldh;
-#ifdef DEBUG
   dlog("Bound to %s:%d\n", aldh->hostent->host, aldh->hostent->port);
-#endif /* DEBUG */
-  if (get_ldap_timestamp(aldh->ldap, map, ts))
+  if (get_ldap_timestamp(aldh, map, ts))
     return (ENOENT);
-#ifdef DEBUG
-  dlog("Got timestamp for map %s: %ld\n", map, *ts);
-#endif /* DEBUG */
+  dlog("Got timestamp for map %s: %ld\n", map, (u_long) *ts);
 
   return (0);
 }
@@ -235,20 +288,24 @@ static int
 amu_ldap_rebind(ALD *a)
 {
   LDAP *ld;
-  HE *h;
+  HE_ENT *h;
   CR *c = a->credentials;
-  time_t now = clocktime();
+  time_t now = clocktime(NULL);
   int try;
 
+  dlog("-> amu_ldap_rebind\n");
+
   if (a->ldap != NULL) {
     if ((a->timestamp - now) > AMD_LDAP_TTL) {
-#ifdef DEBUG
-      dlog("Reestablishing ldap connection\n");
-#endif /* DEBUG */
-      ldap_unbind(a->ldap);
+      dlog("Re-establishing ldap connection\n");
+      amu_ldap_unbind(a->ldap);
       a->timestamp = now;
-    } else
+      a->ldap = NULL;
+    } else {
+      /* Assume all is OK.  If it wasn't we'll be back! */
+      dlog("amu_ldap_rebind: timestamp OK\n");
       return (0);
+    }
   }
 
   for (try=0; try<10; try++) {	/* XXX: try up to 10 times (makes sense?) */
@@ -257,17 +314,34 @@ amu_ldap_rebind(ALD *a)
 	plog(XLOG_WARNING, "Unable to ldap_open to %s:%d\n", h->host, h->port);
 	break;
       }
+#if LDAP_VERSION_MAX > LDAP_VERSION2
+      /* handle LDAPv3 and heigher, if available and amd.conf-igured */
+      if (gopt.ldap_proto_version > LDAP_VERSION2) {
+        if (!ldap_set_option(ld, LDAP_OPT_PROTOCOL_VERSION, &gopt.ldap_proto_version)) {
+          dlog("amu_ldap_rebind: LDAP protocol version set to %ld\n",
+	       gopt.ldap_proto_version);
+        } else {
+          plog(XLOG_WARNING, "Unable to set ldap protocol version to %ld\n",
+	       gopt.ldap_proto_version);
+	  break;
+        }
+      }
+#endif /* LDAP_VERSION_MAX > LDAP_VERSION2 */
       if (ldap_bind_s(ld, c->who, c->pw, c->method) != LDAP_SUCCESS) {
 	plog(XLOG_WARNING, "Unable to ldap_bind to %s:%d as %s\n",
 	     h->host, h->port, c->who);
 	break;
       }
       if (gopt.ldap_cache_seconds > 0) {
+#if defined(HAVE_LDAP_ENABLE_CACHE) && defined(HAVE_EXTERN_LDAP_ENABLE_CACHE)
 	ldap_enable_cache(ld, gopt.ldap_cache_seconds, gopt.ldap_cache_maxmem);
-	a->ldap = ld;
-	a->timestamp = now;
-	return (0);
+#else /* not defined(HAVE_LDAP_ENABLE_CACHE) && defined(HAVE_EXTERN_LDAP_ENABLE_CACHE) */
+	plog(XLOG_WARNING, "ldap_enable_cache(%ld) is not available on this system!\n", gopt.ldap_cache_seconds);
+#endif /* not defined(HAVE_LDAP_ENABLE_CACHE) && defined(HAVE_EXTERN_LDAP_ENABLE_CACHE) */
       }
+      a->ldap = ld;
+      a->timestamp = now;
+      return (0);
     }
     plog(XLOG_WARNING, "Exhausted list of ldap servers, looping.\n");
   }
@@ -278,24 +352,24 @@ amu_ldap_rebind(ALD *a)
 
 
 static int
-get_ldap_timestamp(LDAP * ld, char *map, time_t *ts)
+get_ldap_timestamp(ALD *a, char *map, time_t *ts)
 {
   struct timeval tv;
   char **vals, *end;
   char filter[MAXPATHLEN];
   int i, err = 0, nentries = 0;
-  LDAPMessage *res, *entry;
+  LDAPMessage *res = NULL, *entry;
+
+  dlog("-> get_ldap_timestamp: map <%s>\n", map);
 
   tv.tv_sec = 3;
   tv.tv_usec = 0;
-  sprintf(filter, AMD_LDAP_TSFILTER, map);
-#ifdef DEBUG
+  xsnprintf(filter, sizeof(filter), AMD_LDAP_TSFILTER, map);
   dlog("Getting timestamp for map %s\n", map);
   dlog("Filter is: %s\n", filter);
   dlog("Base is: %s\n", gopt.ldap_base);
-#endif /* DEBUG */
   for (i = 0; i < AMD_LDAP_RETRIES; i++) {
-    err = ldap_search_st(ld,
+    err = ldap_search_st(a->ldap,
 			 gopt.ldap_base,
 			 LDAP_SCOPE_SUBTREE,
 			 filter,
@@ -305,19 +379,32 @@ get_ldap_timestamp(LDAP * ld, char *map, time_t *ts)
 			 &res);
     if (err == LDAP_SUCCESS)
       break;
-#ifdef DEBUG
-    dlog("Timestamp search timed out, trying again...\n");
-#endif /* DEBUG */
+    if (res) {
+      ldap_msgfree(res);
+      res = NULL;
+    }
+    plog(XLOG_USER, "Timestamp LDAP search attempt %d failed: %s\n",
+	 i + 1, ldap_err2string(err));
+    if (err != LDAP_TIMEOUT) {
+      dlog("get_ldap_timestamp: unbinding...\n");
+      amu_ldap_unbind(a->ldap);
+      a->ldap = NULL;
+      if (amu_ldap_rebind(a))
+        return (ENOENT);
+    }
+    dlog("Timestamp search failed, trying again...\n");
   }
 
   if (err != LDAP_SUCCESS) {
     *ts = 0;
     plog(XLOG_USER, "LDAP timestamp search failed: %s\n",
-	 ldap_err2string(ld->ld_errno));
+	 ldap_err2string(err));
+    if (res)
+      ldap_msgfree(res);
     return (ENOENT);
   }
 
-  nentries = ldap_count_entries(ld, res);
+  nentries = ldap_count_entries(a->ldap, res);
   if (nentries == 0) {
     plog(XLOG_USER, "No timestamp entry for map %s\n", map);
     *ts = 0;
@@ -325,19 +412,16 @@ get_ldap_timestamp(LDAP * ld, char *map, time_t *ts)
     return (ENOENT);
   }
 
-  entry = ldap_first_entry(ld, res);
-  vals = ldap_get_values(ld, entry, AMD_LDAP_TSATTR);
+  entry = ldap_first_entry(a->ldap, res);
+  vals = ldap_get_values(a->ldap, entry, AMD_LDAP_TSATTR);
   if (ldap_count_values(vals) == 0) {
     plog(XLOG_USER, "Missing timestamp value for map %s\n", map);
     *ts = 0;
     ldap_value_free(vals);
     ldap_msgfree(res);
-    ldap_msgfree(entry);
     return (ENOENT);
   }
-#ifdef DEBUG
   dlog("TS value is:%s:\n", vals[0]);
-#endif /* DEBUG */
 
   if (vals[0]) {
     *ts = (time_t) strtol(vals[0], &end, 10);
@@ -348,7 +432,7 @@ get_ldap_timestamp(LDAP * ld, char *map, time_t *ts)
     }
     if (!*ts > 0) {
       plog(XLOG_USER, "Nonpositive timestamp %ld for map %s\n",
-	   *ts, map);
+	   (u_long) *ts, map);
       err = ENOENT;
     }
   } else {
@@ -359,10 +443,7 @@ get_ldap_timestamp(LDAP * ld, char *map, time_t *ts)
 
   ldap_value_free(vals);
   ldap_msgfree(res);
-  ldap_msgfree(entry);
-#ifdef DEBUG
-  dlog("The timestamp for %s is %ld (err=%d)\n", map, *ts, err);
-#endif /* DEBUG */
+  dlog("The timestamp for %s is %ld (err=%d)\n", map, (u_long) *ts, err);
   return (err);
 }
 
@@ -370,12 +451,15 @@ get_ldap_timestamp(LDAP * ld, char *map, time_t *ts)
 int
 amu_ldap_search(mnt_map *m, char *map, char *key, char **pval, time_t *ts)
 {
-  char **vals, filter[MAXPATHLEN];
+  char **vals, filter[MAXPATHLEN], filter2[2 * MAXPATHLEN];
+  char *f1, *f2;
   struct timeval tv;
   int i, err = 0, nvals = 0, nentries = 0;
-  LDAPMessage *entry, *res;
+  LDAPMessage *entry, *res = NULL;
   ALD *a = (ALD *) (m->map_data);
 
+  dlog("-> amu_ldap_search: map <%s>, key <%s>\n", map, key);
+
   tv.tv_sec = 2;
   tv.tv_usec = 0;
   if (a == NULL) {
@@ -385,43 +469,63 @@ amu_ldap_search(mnt_map *m, char *map, char *key, char **pval, time_t *ts)
   if (amu_ldap_rebind(a))	/* Check that's the handle is still valid */
     return (ENOENT);
 
-  sprintf(filter, AMD_LDAP_FILTER, map, key);
-#ifdef DEBUG
-  dlog("Search with filter: %s\n", filter);
-#endif /* DEBUG */
+  xsnprintf(filter, sizeof(filter), AMD_LDAP_FILTER, map, key);
+  /* "*" is special to ldap_search(); run through the filter escaping it. */
+  f1 = filter; f2 = filter2;
+  while (*f1) {
+    if (*f1 == '*') {
+      *f2++ = '\\'; *f2++ = '2'; *f2++ = 'a';
+      f1++;
+    } else {
+      *f2++ = *f1++;
+    }
+  }
+  *f2 = '\0';
+  dlog("Search with filter: <%s>\n", filter2);
   for (i = 0; i < AMD_LDAP_RETRIES; i++) {
     err = ldap_search_st(a->ldap,
 			 gopt.ldap_base,
 			 LDAP_SCOPE_SUBTREE,
-			 filter,
+			 filter2,
 			 0,
 			 0,
 			 &tv,
 			 &res);
     if (err == LDAP_SUCCESS)
       break;
+    if (res) {
+      ldap_msgfree(res);
+      res = NULL;
+    }
+    plog(XLOG_USER, "LDAP search attempt %d failed: %s\n",
+        i + 1, ldap_err2string(err));
+    if (err != LDAP_TIMEOUT) {
+      dlog("amu_ldap_search: unbinding...\n");
+      amu_ldap_unbind(a->ldap);
+      a->ldap = NULL;
+      if (amu_ldap_rebind(a))
+        return (ENOENT);
+    }
   }
 
   switch (err) {
   case LDAP_SUCCESS:
     break;
   case LDAP_NO_SUCH_OBJECT:
-#ifdef DEBUG
     dlog("No object\n");
-#endif /* DEBUG */
-    ldap_msgfree(res);
+    if (res)
+      ldap_msgfree(res);
     return (ENOENT);
   default:
     plog(XLOG_USER, "LDAP search failed: %s\n",
-	 ldap_err2string(a->ldap->ld_errno));
-    ldap_msgfree(res);
+	 ldap_err2string(err));
+    if (res)
+      ldap_msgfree(res);
     return (EIO);
   }
 
   nentries = ldap_count_entries(a->ldap, res);
-#ifdef DEBUG
   dlog("Search found %d entries\n", nentries);
-#endif /* DEBUG */
   if (nentries == 0) {
     ldap_msgfree(res);
     return (ENOENT);
@@ -433,12 +537,9 @@ amu_ldap_search(mnt_map *m, char *map, char *key, char **pval, time_t *ts)
     plog(XLOG_USER, "Missing value for %s in map %s\n", key, map);
     ldap_value_free(vals);
     ldap_msgfree(res);
-    ldap_msgfree(entry);
     return (EIO);
   }
-#ifdef DEBUG
   dlog("Map %s, %s => %s\n", map, key, vals[0]);
-#endif /* DEBUG */
   if (vals[0]) {
     *pval = strdup(vals[0]);
     err = 0;
@@ -447,7 +548,6 @@ amu_ldap_search(mnt_map *m, char *map, char *key, char **pval, time_t *ts)
     err = ENOENT;
   }
   ldap_msgfree(res);
-  ldap_msgfree(entry);
   ldap_value_free(vals);
 
   return (err);
@@ -460,15 +560,13 @@ amu_ldap_mtime(mnt_map *m, char *map, time_t *ts)
   ALD *aldh = (ALD *) (m->map_data);
 
   if (aldh == NULL) {
-#ifdef DEBUG
     dlog("LDAP panic: unable to find map data\n");
-#endif /* DEBUG */
     return (ENOENT);
   }
   if (amu_ldap_rebind(aldh)) {
     return (ENOENT);
   }
-  if (get_ldap_timestamp(aldh->ldap, map, ts)) {
+  if (get_ldap_timestamp(aldh, map, ts)) {
     return (ENOENT);
   }
   return (0);
